% ****************************************************
% main program for demonstration how to call the 
% procedure lnpr (Lomb-Scargle Periodogram for Reconstruction)  
% ****************************************************
% example for ozone, 
% for Figure  4 !!!
 clear
 
%save /export/scratch/gromos/mat/somoramat o3 tem p h time yyyymm

%load /export/scratch/gromos/mat/somoramat
load somoramat

 t1=datenum(2004,7,10);
 t2=t1+40;


 
 ind=find(time >= t1 & time <=t2);
 x=time(ind);
 day0=fix(x(1));
 x=x-day0;
 jj=17
 y=o3(ind,jj)*1e6;   % h=52 km
 n=length(x);
 

 xo=x;
 yo=y;
 my=mean(y);
 y=y-my;
 
 fa=1
 win=1
 if win 
  	window=hamming(n);
 	y=y.*window;
 	fa=2;
 end
 y=y+my;
 
 
days=x(end)-x(1);
%ndp=24*2;

%!!!!!!!!!!!!!!  call of procedure  !!!!!!!!!!!!!!!


[wk1,wk2,ph,vari,hifac,ofac,F,teta]=lspr(x,y);


%;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

%amplitude
am=fa*sqrt(wk2*2*vari*2/n); % not considered here 


%manipulation of the Fourier spectrum F:
Fo=F;
conf=98;   %confidence level 
alpha=(100-conf)/2/100;
a=norminv([alpha,1-alpha],0,1);   %
level=a(2) ; 

nf=length(F);
spec=F(2:fix(nf/12));  %consider only a part of the spectrum for confidence estimation
noise_limit=sqrt(level*mean(spec.*conj(spec))); % root of level*mean power of spectrum

ind=find(abs(F) < noise_limit) ;
%F(ind)=0; F(1)=Fo(1);           % no removal of noise

%-------------------
figure(2)
clf
fs=15
lw=2
%;frequency axis in cycles per day
dim=length(wk1);
f=wk1;

ao_spec=abs(Fo(2:dim+1))*2/length(F);
plot(f,ao_spec,'r','linewidth',1.2)
hold on
a_spec=abs(F(2:dim+1))*2/length(F);
plot(f,a_spec,'*','markersize',8)
set(gca,'xscale','log')
xli=[5e-3,20];
xlim(xli);
ylim([0,max(ao_spec)*1.2])
yli=get(gca,'ylim');
plot(xli,2/length(F)*noise_limit*[1,1],'k--','linewidth',2)


grid on

%ome1=ome/days;
%for i=1:nn
%plot(ome1(i)*[1,1],yli,'k--')
%end
leg=legend('original spectrum','manipulated',2)
set(leg,'fontsize',fs)
xlabel('frequency [cycles/day]','fontsize',fs)
ylabel('amplitude [arbitrary units]','fontsize',fs)
set(gca,'xminortick','on','fontsize',fs,'linewidth',1.5,'ticklength',[0.035 0.035])
filenam='/export/scratch/picture/eps/lspr_ozone_spec'
%print('-depsc2','-painters',filenam );
%print('-djpeg','-painters',filenam );



figure(1)
Fb=ifft(F);  % inverse Fourier transform 
yf=real(Fb);       
yi=imag(Fb);

% generation of 'time vector' xf belonging to 'time series' yf:
n=length(F)
xf=x(1)+[0 (1:length(F))/(wk1(2)-wk1(1))/length(F)];

ind=find(xf <= x(end));
xf=xf(ind);
yf=yf(ind);
yi=yi(ind);


% window correction (rescaling to the state without windowing)
if win 
yf=yf./hamming(length(yf))';
end

sc=1
sc=mean(abs(yo-mean(yo)))/mean(abs(yf));  % renormalization is better if the complete spectrum has been taken   
yf=sc*yf + real(F(1));


clf
fs=14
lw=1.5 

plot(xo,yo,'k','linewidth',.8)
hold on
plot(xf,yf,'r','linewidth',.8)

ylabel('O_3 VMR [ppm]','fontsize',fs)
xstr=['days since ' datestr(day0)]
xlabel(xstr,'fontsize',fs)
%title('c) blue curve is reconstructed from the red curve and agrees with the green curve')
%xlabel('time [day]')

xlim([5,18])
yli=[1,3.7];
ylim(yli)

leg=legend('original series','reconstructed series',2)

if 0
[sza,tsr,tss]=solar_zenith_angle_srss(day0+12,46.8,6.95) ; 
plot((tsr(3,2)/24+12)*[1,1],yli,'b','linewidth',lw)
plot((tss(3,2)/24+12)*[1,1],yli,'g','linewidth',lw)

[sza,tsr,tss]=solar_zenith_angle_srss(day0+11,46.8,6.95)  ;
plot((tss(3,2)/24+11)*[1,1],yli,'g','linewidth',lw)
plot((tsr(3,2)/24+11)*[1,1],yli,'b','linewidth',lw)
end


set(gca,'xminortick','on','fontsize',fs,'linewidth',1.2,'ticklength',[0.03 0.03])
set(leg,'fontsize',fs,'linewidth',1.5)

filenam='/export/scratch/picture/eps/lspr_ozone'
%print('-depsc2','-painters',filenam );
%print('-djpeg','-painters',filenam );



















