% ****************************************************
% main program for demonstration how to call the 
% procedure lnpr (Lomb-Scargle Periodogram for Reconstruction)  
% ****************************************************
% example for ozone
% for Figure 7
 clear
 
%save /export/scratch/gromos/mat/somoramat o3 tem p h time yyyymm

load /export/scratch/gromos/mat/somoramat
 %load /export/scratch/gromos/mat/gromosmat
%load somoramat

 t1=datenum(2005,12,1);
 t2=t1+90;


 
 ind=find(time >= t1 & time <=t2);
 x=time(ind);
 day0=fix(x(1));
 x=x-day0;
 jj=36
 jj=17
 y=o3(ind,jj)*1e6;   % h=52 km
 n=length(x);
 

xo=x;
yo=y;
 my=mean(y);
 y=y-my;
 
 fa=1
 win=0
 if win 
  	window=hamming(n);
 	y=y.*window;
 	fa=2;
 end
 y=y+my;
 
 
% plot(x,y)


days=x(end)-x(1);
%ndp=24*2;

%!!!!!!!!!!!!!!  call of procedure  !!!!!!!!!!!!!!!


[wk1,wk2,ph,vari,hifac,ofac,F]=lspr(x,y);


%;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

%amplitude
am=fa*sqrt(wk2*2*vari*2/n); % not considered here 

%manipulation of the Fourier spectrum F:
Fo=F;
nn=length(F);
conf=98;   %confidence level 
alpha=(100-conf)/2/100;
a=norminv([alpha,1-alpha],0,1);   %
level=a(2) ; 
nf=length(F);
spec=F(2:fix(nf/6));
noise_limit=sqrt(level*mean(spec.*conj(spec))); %  level*mean power of spectra

%or :
%level=max(abs(F(2:end)))/4;

%noise_limit=level;

ind=find(abs(F) < noise_limit) ;
F(ind)=0; F(1)=Fo(1);           %removal of noise


%-------------------
figure(2)
clf
fs=15
lw=2
%;frequency axis in cycles per day
dim=length(wk1);
%f=wk1/wk1(1)/days/ofac;
f=wk1;
plot(f,abs(Fo(2:dim+1)),'r','linewidth',1.2)
hold on
plot(f,abs(F(2:dim+1)),'*','markersize',8)
set(gca,'xscale','log')
xli=[5e-3,20];
xlim(xli);
yli=get(gca,'ylim');
plot(xli,noise_limit*[1,1],'k--','linewidth',lw)
grid on

%ome1=ome/days;
%for i=1:nn
%plot(ome1(i)*[1,1],yli,'k--')
%end
leg=legend('original spectrum','manipulated',2)
set(leg,'fontsize',fs)
xlabel('frequency [cycles/day]','fontsize',fs)
ylabel('amplitude [arbitrary units]','fontsize',fs)

set(gca,'xminortick','on','fontsize',fs,'linewidth',1.5,'ticklength',[0.035 0.035])
filenam='/export/scratch/picture/eps/lnpr_ozone_spec1free'
%print('-depsc2','-painters',filenam );
%print('-djpeg','-painters',filenam );



figure(1)
Fb=ifft(F);  % inverse Fourier transform 
yf=real(Fb);       
yi=imag(Fb);

% generation of 'time vector' xf belonging to 'time series' yf:
n=length(F)
xf=x(1)+[0 (1:length(F))/(wk1(2)-wk1(1))/length(F)];


ind=find(xf <= x(end));
xf=xf(ind);
yf=yf(ind);
yi=yi(ind);


% window correction (rescaling to the state without windowing)
if win 
yf=yf./hamming(length(yf))';
end


% adjustment/scaling of yf by using the original series y:    
%yf=mean(abs(yo-mean(yo)))/mean(abs(yf))*yf + real(F(1));
yf=yf+real(F(1));




clf
fs=14
lw=1.5 

plot(xo,yo,'k','linewidth',.8)
hold on

plot(xf,yf,'r','linewidth',lw)


ylabel('O_3 VMR [ppm]','fontsize',fs)
xstr=['days since ' datestr(day0)]
xlabel(xstr,'fontsize',fs)
%title('c) blue curve is reconstructed from the red curve and agrees with the green curve')
%xlabel('time [day]')

xlim([6,18])
yli=[0.5,4];
%ylim(yli)

if 1
[sza,tsr,tss]=solar_zenith_angle_srss(day0+11,46.8,6.95) ; 
plot((tsr(3,2)/24+12)*[1,1],yli,'b','linewidth',lw)
plot((tss(3,2)/24+12)*[1,1],yli,'g','linewidth',lw)

leg=legend('original series','reconstructed series','sunrise','sunset',2)



[sza,tsr,tss]=solar_zenith_angle_srss(day0+12,46.8,6.95)  ;
plot((tss(3,2)/24+13)*[1,1],yli,'g','linewidth',lw)
plot((tsr(3,2)/24+13)*[1,1],yli,'b','linewidth',lw)

end

set(gca,'xminortick','on','fontsize',fs,'linewidth',1.2,'ticklength',[0.03 0.03])
set(leg,'fontsize',fs,'linewidth',1.5)

filenam='/export/scratch/picture/eps/lspr_ozone2'
%print('-depsc2','-painters',filenam );
%print('-djpeg','-painters',filenam );



















